import { IListable } from '../interfaces/listable-interface';

export abstract class DefaultListable<T> implements IListable<T> {

    private isForSearch: boolean;
    private isForDelete: boolean;
    private _elements: Array<T>;
    private _elementsAux: Array<T>;
    private _selectedIndex: number;

    constructor(
    ) {
        this.isForSearch = false;
        this.isForDelete = false;
        this._elements = [];
        this._elementsAux = [];
        this._selectedIndex = -1;
    }

    /**
     *
     */
    set elements(_elements: Array<T>) {
        this._elements = _elements; 
    }

    /**
     *
     */
    set selectedIndex(_selectedIndex: number) {
        this._selectedIndex = _selectedIndex;
    }

    /**
     *
     */
    get elements() {
        return this._elements;
    }

    /**
     *
     */
    get selectedIndex(): number {
        return this._selectedIndex;
    }

    /**
     *
     */
    add(T: any): void {
        this._elements.push(T);
    }

    /**
     *
     */
    remove(T: any): void {
        let index = this.elements.indexOf(T);
        this._elements.splice(index, 1);
    }

    /**
     *
     */
    get(T: any): T {
        let index = this.elements.indexOf(T);
        return this._elements[index];
    }

    /**
     *
     */
    list(): Array<T> {
        return this._elements;
    }

    /**
     *
     */
    search(event: any): void {
        let value: string = event.target.value;
        this._elements = this._elementsAux;

        this.elements = this.elements.filter(item => {
            return (item as any).name.toLowerCase().indexOf(value.toLowerCase()) > -1;
        });
    }

    /**
     *
     */
    toggleSearch(): void {
        this.isForSearch = !this.isForSearch;

        if (this.isForSearch) {
            this._elementsAux = this.elements;
        } else {
            this._elements = this._elementsAux;
        }
    }

    /**
     *
     */
    toggleDelete(index: number): void {
        this.selectedIndex = index;

        if (this.selectedIndex != -1) {
            this.isForDelete = true;
        } else {
            this.isForDelete = !this.isForDelete;
        }    
    }

    /**
     *
     */
    isSearching(): boolean {
        return this.isForSearch;
    }

    /**
     *
     */
    isDeleting(): boolean {
        return this.isForDelete;
    }
}
